
struct rcVarPointers
{
/*
  You MUST NOT change any of the End pointers, or EndChars.
  You can change the Start pointers freely, so long as you
  don't change their NULL/non-NULL status.
  Also, leave the string pointed to by these unchanged.

  { @ab c ( \d e( f ) )\ghi}
  NameStart -> "ab"
  ParamStart -> " \d e( f "
*/
  TCHAR *VarStart, *VarEnd;
  TCHAR *NameStart, *NameEnd;
  DWORD NameHash;
  TCHAR *ParamStart, *ParamEnd;
  TCHAR *TransformStart, *TransformEnd;
  DWORD TransformHash;
  TCHAR VarEndChar, NameEndChar, ParamEndChar, TransformEndChar;
};

typedef size_t (*rcVarLookupProc)(rcVarPointers *var, TCHAR *dest, size_t maxchars, DWORD lParam);

// you can't remove things, only set them to NULL and ignore them
struct rcVarLookup
{
  size_t nSize;
  rcVarLookupProc At;
  rcVarLookupProc Def;
};

// never change this, only add new ones
#define RCVARLOOKUP1_SIZE (4*3)


bool rcVarReplace(TCHAR *src, TCHAR *dest, size_t maxchars, const rcVarLookup *lookup, DWORD lParam);
